<ui:composition xmlns:gri="http://java.sun.com/jsf/composite/gri" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:c="http://java.sun.com/jsp/jstl/core"
                xmlns:gdk="http://www.ihe.net/gazellecdk" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns="http://www.w3.org/1999/xhtml"
                template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form>
            <h1>#{messages['gazelle.ordermanager.LaboratoryLabelBroker']}</h1>
            <gri:panel>
                <f:facet name="header">#{messages['gazelle.ordermanager.LabelsContainersDelivered']}</f:facet>
                <s:div id="globalDiv">
                    <ui:include src="/configuration/initiatorFrame.xhtml">
                        <ui:param name="actorKeyword" value="#{labelDeliveredSender.sutActor.keyword}"/>
                        <ui:param name="diagramImg" value="diag/LAB-63-LIP-SUT.png"/>
                        <ui:param name="simuApplication" value="#{messages['gazelle.ordermanager.OMLABLB']}"/>
                        <ui:param name="simuFacility" value="#{messages['gazelle.ordermanager.IHE']}"/>
                        <ui:param name="sectionsToReRender" value="requestParameters"/>
                        <ui:param name="currentConfig" value="#{userPreferencesManagerBean.selectedSUT}"/>
                        <ui:param name="simulatorConfigurationName"
                                  value="#{messages['gazelle.ordermanager.LabelBrokerSimulator']}"/>
                        <ui:param name="availableSuts"
                                  value="#{hl7v2ResponderSUTConfiguration.getAllConfigurationsForSelection('LAB-63', 'MLLP')}"/>
                    </ui:include>
                    <br/>
                    <s:div id="requestParameters">
                        <s:div rendered="#{labelDeliveredSender.hl7Messages == null}">
                            <gri:panel>
                                <f:facet name="header">#{messages['gazelle.ordermanager.SelectDeliveredLabels']}
                                </f:facet>
                                <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                                    <ui:define name="filter_buttons">
                                        <a4j:commandLink title="#{messages['gazelle.ordermanager.RefreshResults']}"
                                                         render="specimenSelectionP">
                                            <span class="gzl-icon-refresh"/>
                                        </a4j:commandLink>
                                        <a4j:commandLink title="#{messages['gazelle.hl7.validator.ResetCriteria']}"
                                                         actionListener="#{labelDeliveredSender.specimenFilter.reset()}"
                                                         render="specimenSelectionP">
                                            <span class="gzl-icon-times-circle"/>
                                        </a4j:commandLink>
                                    </ui:define>
                                    <ui:include src="/common/filtersOnSpecimen.xhtml">
                                        <ui:param name="filterClass" value="#{labelDeliveredSender.specimenFilter}"/>
                                        <ui:param name="formId" value="specimenSelectionP"/>
                                    </ui:include>
                                    <ui:decorate template="/layout/form/_form_checkbox_horizontal_3-9.xhtml">
                                        <h:selectBooleanCheckbox
                                                value="#{labelDeliveredSender.specimenFilter.hideDeliveredLabels}">
                                            <a4j:ajax event="change" render="specimenSelectionP"/>
                                        </h:selectBooleanCheckbox>
                                        #{messages['gazelle.ordermanager.HideAlreadyDeliveredLabels']}
                                    </ui:decorate>
                                </ui:decorate>
                                #{dataTableStateHolder.setDescendingOn('lastChanged')}
                                <rich:dataTable value="#{labelDeliveredSender.specimenFilter.getSpecimens()}" var="spm"
                                                rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                                id="spmlistall" render="ds">
                                    <ui:include src="/lab/specimenColumns.xhtml">
                                        <ui:param name="specimen" value="#{spm}"/>
                                    </ui:include>
                                    <g:column>
                                        <ui:define name="header">#{messages['gazelle.ordermanager.Creator']}</ui:define>
                                        <h:outputText value="#{spm.creator}"/>
                                    </g:column>
                                    <g:column sortBy="#{'lastChanged'}"
                                              sortOrder="#{dataTableStateHolder.sortOrders['lastChanged']}">
                                        <ui:define name="header">#{messages['gazelle.ordermanager.LastModifiedOn']}</ui:define>
                                        <g:date value="#{spm.lastChanged}"/>
                                    </g:column>
                                    <g:column>
                                        <ui:define name="header">#{messages['users.Action']}</ui:define>
                                        <div class="gzl-never-wrap">
                                            <a4j:commandLink title="#{messages['gazelle.ordermanager.SendNotification']}"
                                                             actionListener="#{labelDeliveredSender.sendMessage(spm)}"
                                                             render="globalDiv">
                                                <span class="fa fa-check-square-o gzl-text-blue"/>
                                            </a4j:commandLink>
                                            <a4j:commandLink title="#{messages['gazelle.ordermanager.AddToList']}"
                                                             actionListener="#{labelDeliveredSender.addSpecimenToList(spm)}"
                                                             render="spmlistall, sendAllBtn"
                                                             rendered="#{not labelDeliveredSender.isSpecimenSelected(spm)}">
                                                <span class="gzl-icon-plus"/>
                                            </a4j:commandLink>
                                            <a4j:commandLink title="#{messages['gazelle.ordermanager.RemoveFromList']}"
                                                             actionListener="#{labelDeliveredSender.removeSpecimenFromList(spm)}"
                                                             render="spmlistall, sendAllBtn"
                                                             rendered="#{labelDeliveredSender.isSpecimenSelected(spm)}">
                                                <span class="gzl-icon-trash-o"/>
                                            </a4j:commandLink>
                                        </div>
                                    </g:column>
                                    <f:facet name="footer">
                                        <ui:include src="/util/datatableFooter.xhtml">
                                            <ui:param name="dataScrollerId" value="ds"/>
                                            <ui:param name="dataTableId" value="spmlistall"/>
                                        </ui:include>
                                    </f:facet>
                                </rich:dataTable>
                                <f:facet name="footer">
                                    <a4j:commandButton value="#{messages['gazelle.ordermanager.SendSelectedLabels']} (#{labelDeliveredSender.getLabelCount()})"
                                                       actionListener="#{labelDeliveredSender.sendMessageForList()}"
                                                       render="globalDiv" styleClass="gzl-btn-blue"
                                                        id="sendAllBtn"/>
                                </f:facet>
                            </gri:panel>
                        </s:div>
                    </s:div>
                    <!--  response div -->
                    <s:div id="hl7MessagesDiv">
                        <s:decorate template="/layout/panels/_panel_title_footer.xhtml"
                                    rendered="#{labelDeliveredSender.hl7Messages != null}">
                            <ui:define name="panel_title">#{messages['gazelle.ordermanager.TestReport']}</ui:define>
                            <ui:include src="/messages/message_table.xhtml">
                                <ui:param name="hl7Messages" value="#{labelDeliveredSender.hl7Messages}"/>
                            </ui:include>
                            <ui:define name="panel_footer">
                                <a4j:commandButton value="#{messages['gazelle.ordermanager.PerformAnotherTest']}"
                                                   actionListener="#{labelDeliveredSender.init()}"
                                                   styleClass="gzl-btn-blue"
                                                   render="hl7MessagesDiv,requestParameters"/>
                            </ui:define>
                        </s:decorate>
                    </s:div>
                </s:div>
            </gri:panel>
        </h:form>
    </ui:define>
</ui:composition>
